; TIP1140.LSP: LINMAKE.LSP   Extract Linetypes   (c)1995, Garrett Brittenham

; I have set the accuracy of the dxfout to 4 decimal places.  You may want
; to increase or decrease this number depending on your accuracy requirements.
; Remember, however, that the higher this number is, the longer this routine
; takes to run.  To change this number, find the line that begins with 
; (command "dxfout" in the dxfit subroutine, and change the "4" to whatever
; number you feel is appropriate (0-16).

(defun *error* (MSG)
  (princ "Error: ")
  (princ MSG)
  (terpri)
)

; DXFIT creates a dxf file with the same name and in the same directory as 
; your drawing file
(defun dxfit (/ YN FFILE)
  (setq FFILE (findfile (strcat (getvar "DWGNAME") ".dxf")))
  (if FFILE
    (progn
      (initget "Yes No")
      (princ (strcat "\n DXF file " (getvar "DWGNAME") " already exists..."))
      (setq YN (getkword "\nUse existing DXF file? "))
      (if (equal YN "No") 
        (progn
          (princ "\nBuilding new DXF file...")
          (command "dxfout" (getvar "DWGNAME") "4")
        ) ;progn
      ) ;if
      (if (equal YN "Yes") (princ "\nUsing existing DXF file..."))
    ) ;progn
    (progn
      (princ (strcat "\nCreating " (getvar "DWGNAME") ".DXF..."))
      (command "dxfout" (getvar "DWGNAME") "4")
    ) ;progn
  ) ;if
) ;defun

; WRITELIN writes pertinent linetype definition information to the linetype
; file named in C:MAKE
(defun writelin (/ A1 FFILE FLE2)
  (setq FFILE (findfile (strcat FNAME ".lin")))
  (if FFILE
    (setq FLE2 (open (strcat FNAME ".lin") "a"))
    (setq FLE2 (open (strcat FNAME ".lin") "w"))
  ) ;if
  (setq A1 (read-line FLE1))
  (if (equal A1 "  2")
    (progn
      (setq A A1)
      (while (/= A "  0")
        (if (equal A "  2")
          (progn
            (setq A (read-line FLE1))
            (princ (strcat "*" A ",") FLE2)
          ) ;progn
        ) ;if
        (if (equal A "  3")
          (progn
            (setq A (read-line FLE1))
            (princ (strcat A "\n") FLE2)
          ) ;progn
        ) ;if
        (if (equal A " 40")
          (progn
            (setq A (read-line FLE1))
            (if (equal A "0.0") (princ "A,1,1" FLE2) (princ "A" FLE2))
          ) ;progn
        ) ;if
        (if (equal A " 49")
          (progn
            (setq A (read-line FLE1))
            (princ (strcat "," A) FLE2)
          ) ;progn
        ) ;if
        (setq A (read-line FLE1))
      ) ;while
      (princ "\n" FLE2)
    ) ;progn
  ) ;if
  (close FLE2)
) ;defun

; READDXF reads the dxf file, searching for the "LTYPE" definition section
(defun readdxf (/ A FLE1)
  (setq a nil fle1 nil)
  (princ (strcat "\nReading linetype information from " (getvar "DWGNAME") ".DXF"))
  (setq FLE1 (open (strcat (getvar "DWGNAME") ".dxf") "r"))
  (setq A "begin")
  (while A 
    (setq A (read-line FLE1))
    (if (equal A "LTYPE") (writelin))
  ) ;while
  (close FLE1)
) ;defun

; C:MAKE asks for a linetype file name and gives you the option to erase the 
; dxf file created in DXFIT
(defun C:MAKE (/ FNAME YN)
  (setvar "CMDECHO" 0)
  (setq FNAME (getstring "\nEnter name of linetype file to create: "))
  (dxfit)
  (readdxf)
  (initget "Yes No")
  (setq YN (getkword "\nErase created DXF file? "))
  (if (equal YN "Yes") (command "files" "3" 
  (strcat (getvar "DWGNAME") ".dxf") "" "0"))
) ;end linmake.lsp
