; TIP1142.LSP: VT.LSP   View Text   (c)1995, Jonathan Pruett
;    $50 Bonus Winner

; NOTE: As written this routine works with 
; AutoCAD for DOS ONLY. 
; The (grread) function returns three different values for some keys
; based on the version of AutoCAD; R12/R13 DOS, R12 Win, or R13 Win.

(defun C:VT ()
  (defun newerr (a)
    (setq *error* OLDERR)
    (if (= A "") (setq ORIG TXT))
    (entmod (subst (cons 1 ORIG) (assoc 1 ENTITY) ENTITY))
    (foreach X '(entity txt txtlen curpos key orig u inst disp olderr)
      (set X nil)
    )
    (grtext)
    (princ)
  )
  (while (/= "TEXT" (cdr (assoc 0 (setq ENTITY (entget (car (entsel))))))))
  (setq OLDERR *error* *error* NEWERR
    TXT (cdr (assoc 1 ENTITY))
    TXTLEN (1+ (strlen TXT))
    ORIG TXT
    U "%%u"
    CURPOS 1
    INST (grtext -1 "Insert Mode")
  )
  (princ "\n    <Right> <Left> <Del> <Backspace> <Insert>")
  (princ "\n <Ctrl-Right> <Ctrl-Left> <Ctrl-Del> <Home> <End>")
  (princ "\n Return to Save  -  <Ctrl-C> To Restore Origional")
  (entmod
    (setq DISP (strcat U (substr TXT 1 1) U (substr TXT 2))
    entity (subst (cons 1 DISP) (assoc 1 ENTITY) ENTITY))
  )
  (while (/= KEY 13)  ;not return return
    (setq KEY (cadr (grread nil 22 1)))
    (cond
      ((= KEY 199) (setq CURPOS 1)) ;Home
      ((= KEY 207) (setq CURPOS TXTLEN)) ;end
      ((= KEY 203)   ;left
        (setq CURPOS (1- CURPOS))
        (if (< CURPOS 1) (setq CURPOS TXTLEN))
      )
      ((= KEY 205)   ;right
        (setq CURPOS (1+ CURPOS))
        (if (> CURPOS TXTLEN) (setq CURPOS 1))
      )
      ((= KEY 243)   ;control left
        (setq CURPOS (- CURPOS 5))
        (if (< CURPOS 1) (setq CURPOS TXTLEN))
      )
      ((= KEY 244)   ;control right
        (setq CURPOS (+ CURPOS 5))
        (if (> CURPOS TXTLEN) (setq CURPOS 1))
      )
      ((= KEY 127)   ;delete
        (setq TXT
          (strcat (substr TXT 1 (1- CURPOS)) (substr TXT (1+ CURPOS)))
          TXTLEN (1+ (strlen TXT))
        )
      )
      ((= KEY 147)   ;control delete
        (setq TXT
          (strcat (substr TXT 1 (1- CURPOS)) (substr TXT (+ 5 CURPOS)))
          TXTLEN (1+ (strlen TXT))
        )
      )
      ((and (= KEY 8) (> CURPOS 1)) ;backspace
        (setq CURPOS (1- CURPOS))
        (setq TXT
          (strcat (substr TXT 1 (1- CURPOS)) (substr TXT (1+ CURPOS)))
          TXTLEN (1+ (strlen TXT))
        )
      )
      ((= KEY 210)    ;insert toggle
        (if (= INST "Insert Mode")
          (setq INST (grtext -1 "Typeover Mode"))
          (setq INST (grtext -1 "Insert Mode"))
        )
      )
      ((and (> KEY 31) (< KEY 127))  ;any standard character
        (if (= INST "Insert Mode")
          (setq TXT (strcat (substr TXT 1 (1- CURPOS)) (chr KEY)
            (substr TXT CURPOS))
            TXTLEN (1+ (strlen TXT))
            CURPOS (1+ CURPOS)
          )
          (setq TXT (strcat (substr TXT 1 (1- CURPOS)) (chr KEY)
            (substr TXT (1+ CURPOS)))
            TXTLEN (1+ (strlen TXT))
            CURPOS (1+ CURPOS)
          )
        )
      )
    )
    (cond
      ((= CURPOS 1)
        (setq DISP (strcat U (substr TXT 1 1) U (substr TXT 2)))
      )
      ((= CURPOS TXTLEN)
        (setq DISP (strcat (substr TXT 1 (1- CURPOS)) U
          (substr TXT CURPOS))
        )
      )
      ((setq DISP (strcat (substr TXT 1 (1- CURPOS )) U
          (substr TXT CURPOS 1) U (substr TXT (1+ CURPOS)))
        )
      )
    )
    (entmod (setq ENTITY (subst (cons 1 DISP) (assoc 1 ENTITY) ENTITY)))
  )
  (newerr "")
  (princ)
) ;end vt.lsp
